;
; DOOR.ASM
;

; DOOR_OPEN() -----------------------------------------------------------------
; Setup & start door opening
;------------------------------------------------------------------------------
door_open:
        ld      a, 1
        ld      (VAR_door_opening), a
        xor     a
        ld      (VAR_door_anim_frame_cur), a
        ld      a, 1
        ld      (VAR_door_anim_delay), a
        ret

; DOOR_UPDATE() ---------------------------------------------------------------
; Update door animation
;------------------------------------------------------------------------------
door_update:
        ld      a, (VAR_door_anim_delay)
        dec     a
        jr      nz, door_update_end

; FIXME: this code is redundant with animations in char.asm
; Should write a generic (and clean) animation system someday

        ld      a, (VAR_door_anim_frame_cur)
        inc     a
        ld      (VAR_door_anim_frame_cur), a

;       cp      1
;       jr      z, door_update_frame_0
        cp      2
        jr      z, door_update_frame_1
        cp      3
        jr      z, door_update_frame_2
        cp      4
        jr      z, door_update_frame_3
        cp      5
        jr      z, door_update_frame_4

door_update_frame_0:
        ld      de, map_door0front
        jr      door_update_do
door_update_frame_1:
        ld      de, map_door1
        jr      door_update_do
door_update_frame_2:
        ld      a, (VAR_character_current)
        cp      MARIO_IDX
        jr      nz, +3
        call    mario_kick_start
        ld      de, map_door2
        jr      door_update_do
door_update_frame_3:
        ld      de, map_door1
        jr      door_update_do
door_update_frame_4:
        call    character_next
        ld      de, map_door0front
        xor     a
        ld      (VAR_door_anim_frame_cur), a
        ld      (VAR_door_opening), a
        ; jr      door_update_do

door_update_do:
        ld      hl, VRAM_BG_MAP + (22 + 17 * 32) * 2
        ld      b, 4
        ld      c, 6
        call    vdp_load_map_area

        ld      a, 12
door_update_end:
        ld      (VAR_door_anim_delay), a
        ret
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
door_reinit:
        ld      de, map_door0
        ld      hl, VRAM_BG_MAP + (22 + 17 * 32) * 2
        ld      b, 4
        ld      c, 6
        call    vdp_load_map_area
        ret
;------------------------------------------------------------------------------

