;
; Loose Logic demo, dedicated to Masato Ozaki
; by Omar Cornut (Bock);
; 03-27 May 2002
;

.INCLUDE "sms.inc"

; WlaDX stuffs ----------------------------------------------------------------
.EMPTYFILL $00
.SMSTAG
.COMPUTESMSCHECKSUM
.MEMORYMAP
        DEFAULTSLOT     0
        SLOTSIZE        PAGE_SIZE
        SLOT            0               PAGE_0
        SLOT            1               PAGE_1
        SLOT            2               PAGE_2
.ENDME

.ROMBANKMAP
        BANKSTOTAL      8
        BANKSIZE        PAGE_SIZE
        BANKS           8
.ENDRO

;------------------------------------------------------------------------------
.BANK 0 SLOT 0
;------------------------------------------------------------------------------

; Variables -------------------------------------------------------------------
.DEFINE VAR_frame_cnt                   (RAM + $10)     ; 1 byte
.DEFINE VAR_vgm_playing                 (RAM + $11)     ; 1 byte
.DEFINE VAR_vgm_waiting_frames          (RAM + $12)     ; 1 byte
.DEFINE VAR_vgm_song_start              (RAM + $13)     ; 2 bytes
.DEFINE VAR_vgm_song_current            (RAM + $15)     ; 2 bytes
.DEFINE VAR_h_interrupt_step            (RAM + $17)     ; 1 byte
.DEFINE VAR_scroll                      (RAM + $18)     ; 1 byte
.DEFINE VAR_door_opening                (RAM + $19)     ; 1 byte
.DEFINE VAR_door_anim_frame_cur         (RAM + $1A)     ; 1 byte
.DEFINE VAR_door_anim_delay             (RAM + $1B)     ; 1 byte
.DEFINE VAR_character_current           (RAM + $1C)     ; 1 byte
.DEFINE VAR_character_infos             (RAM + $1D)     ; 2 bytes
.DEFINE VAR_character_data_size_frame   (RAM + $1F)     ; 1 byte
.DEFINE VAR_character_data_size_total   (RAM + $20)     ; 2 bytes
.DEFINE VAR_character_anim_frame_cur    (RAM + $22)     ; 1 byte
.DEFINE VAR_character_anim_frame_max    (RAM + $23)     ; 1 byte
.DEFINE VAR_character_anim_delay        (RAM + $24)     ; 1 byte
.DEFINE VAR_character_anim_delay_frame  (RAM + $25)     ; 1 byte
.DEFINE VAR_character_pos_x             (RAM + $26)     ; 1 byte
.DEFINE VAR_character_pos_y             (RAM + $27)     ; 1 byte
.DEFINE VAR_mario_kicking               (RAM + $28)     ; 1 byte
.DEFINE VAR_night_current               (RAM + $29)     ; 1 byte
.DEFINE VAR_night_delay_frames          (RAM + $30)     ; 1 byte
.DEFINE VAR_night_delay_seconds         (RAM + $31)     ; 1 byte
;------------------------------------------------------------------------------

; Start -----------------------------------------------------------------------
.ORGA   $0000
        di
        im      1
        ld      sp,     $DFF0
        jp      start
;------------------------------------------------------------------------------

.REPT 7
        nop
.ENDR

; Tools ---------------------------------------------------------------------
.ORGA   $0010
vdp_write_de:
                ld      a, e
                out     (VDP_ADDR), a
                ld      a, d
                out     (VDP_ADDR), a
                ret
.REPT 1
        nop
.ENDR

.ORGA   $0018
vdp_write_addr_de:
                ld      a, e
                out     (VDP_ADDR), a
                ld      a, d
                or      $40
                out     (VDP_ADDR), a
                ret

.REPT 7
        nop
.ENDR

.ORGA   $0028
vdp_write_addr_hl:
                ld      a, l
                out     (VDP_ADDR), a
                ld      a, h
                or      $40
                out     (VDP_ADDR), a
                ret

.REPT 7
        nop
.ENDR

; Interrupt -------------------------------------------------------------------
.ORGA   $0038
interrupt:
        di
        push    af
        in      a, (VDP_STATUS)
        and     $80
        jr      z, h_interrupt
;------------------------------------------------------------------------------
v_interrupt:
        ld      a, (VAR_frame_cnt)
        inc     a
        ld      (VAR_frame_cnt), a
        call    vgm_update

        xor     a
        ld      (VAR_h_interrupt_step), a
        ld      a, 4*8-1
        out     (VDP_ADDR), a
        ld      a, $8A
        out     (VDP_ADDR), a
        ld      a, 0
        out     (VDP_ADDR), a
        ld      a, $88
        out     (VDP_ADDR), a

;------------------------------------------------------------------------------
interrupt_end:
        pop     af
        ei
        ret
;------------------------------------------------------------------------------

.REPT   5
        nop
.ENDR

; NMI -------------------------------------------------------------------------
.ORGA   $0066
        reti
;------------------------------------------------------------------------------

; SDSC HEADER DATA ------------------------------------------------------------
sdsc_author:            .db     "Omar Cornut / Bock", 0
sdsc_program_name:      .db     "SMS Cast: a Tribute to Loose Logic", 0
sdsc_unused_but_stored: .db     "v:1.0", 0
;------------------------------------------------------------------------------

; Horizontal Interrupt Handler ------------------------------------------------
h_interrupt:
        ;ld      a, (VAR_h_interrupt_step)
        ;inc     a
        ;ld      (VAR_h_interrupt_step), a
        ;cp      $1
        ;jr      z, h_interrupt_1
        ;cp      $2
        ;jr      z, h_interrupt_2
        ;cp      $3
        ;jr      z, h_interrupt_3
        jp      interrupt_end
;------------------------------------------------------------------------------
;h_interrupt_1:
;        ld      a, 1*8-1
;        out     (VDP_ADDR), a
;        ld      a, $8A
;        out     (VDP_ADDR), a
;        jp      interrupt_end
;h_interrupt_2:
;        ld      a, 255
;        out     (VDP_ADDR), a
;        ld      a, $8A
;        out     (VDP_ADDR), a
;        ld      a, (VAR_scroll)
;        out     (VDP_ADDR), a
;        ld      a, $88
;        out     (VDP_ADDR), a
;        jp      interrupt_end
;h_interrupt_3:
;        ld      a, 0
;        out     (VDP_ADDR), a
;        ld      a, $88
;        out     (VDP_ADDR), a
;        jp      interrupt_end
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
start:
        call    vgm_init
        call    vdp_init

        xor     a
        ld      (VAR_scroll), a
        ld      (VAR_frame_cnt), a
        ld      (VAR_door_opening), a

        di

        ; Set Palette to Black
        ld      a, 0
        ld      b, 32
        ld      hl, pal_black
        call    vdp_set_pal

        ; Copy Main Background Tiles
        ld      bc, VRAM_TILE_SIZE * ((tiles_data_end - tiles_data) / 32)
        ld      hl, tiles_data
        ld      de, $0000 + VRAM_TILE_SIZE * 0
        call    vdp_load_data

        ; Copy Font Tiles
        ld      bc, VRAM_TILE_SIZE * ((font_data_end - font_data) / 32)
        ld      hl, font_data
        ld      de, $0000 + VRAM_TILE_SIZE * 112
        call    vdp_load_data

        ; Copy Main Background Map
        ld      hl, map_data
        call    vdp_load_map

        ; Print Text
        ld      hl, string_intro
        ld      de, VRAM_BG_MAP + (1 + 1 * 32) * 2
        ld      c,  0
        call    vdp_print

        ; Initialize First Character
        call    character_init
        call    character_next
        call    character_refresh

        ; Initialize Night System
        call    night_init

        ; Setup VDP Registers
        ld      de, $800E               ; Enable H-Interrupt, Sprite Early Clock
        rst     $10
        ld      de, $81E2               ; Enable display, V-Interrupt, 16x8 sprites
        rst     $10

        ; Fade In
        ld      a, 0
        ld      b, 16
        ld      c, 4
        ld      d, 8
        ld      hl, pal_shop_fade_in
        call    vdp_fade

        ; Start Music
        ld      hl, music_data
        call    vgm_play
;------------------------------------------------------------------------------

; Main Loop -------------------------------------------------------------------
main_loop:

        ; Wait for V-Blank at first
        call    vdp_frame_one

; Refresh ---------------------------------------------------------------------
        ;ld      a, (VAR_scroll)
        ;dec     a
        ;dec     a
        ;ld      (VAR_scroll), a

        ; Update
main_update:
        call    night_update

        ld      a, (VAR_mario_kicking)
        and     a
        jr      z, +8
        call    mario_update
        call    character_update
        jr      main_update_end

        ld      a, (VAR_door_opening)
        and     a
        jr      z, +5
        call    door_update
        jr      main_update_end

        call    character_update
main_update_end:

        ;in      a, (PORT_INPUT1)
        ;and     $10
        ;jr      nz, +3
        ;call    night_switch

        ; Reset
        in      a, (PORT_INPUT2)
        and     $10
        jp      z, $0000
;------------------------------------------------------------------------------

        jp      main_loop
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
night_init:
        xor     a
        ld      (VAR_night_current), a
        ld      a, 1
        ld      (VAR_night_delay_frames), a
        ld      a, 180
        ld      (VAR_night_delay_seconds), a
        ret
;------------------------------------------------------------------------------
night_update:
        ld      a, (VAR_night_delay_frames)
        dec     a
        ld      (VAR_night_delay_frames), a
        jr      z, +1
        ret
        ld      a, 60
        ld      (VAR_night_delay_frames), a
        ld      a, (VAR_night_delay_seconds)
        dec     a
        ld      (VAR_night_delay_seconds), a
        jr      z, +1
        ret
        ld      a, (VAR_night_current)
        inc     a
        ld      (VAR_night_current), a

        cp      1
        jr      z, night_update_day_to_night_0
        cp      2
        jr      z, night_update_day_to_night_1
        cp      3
        jr      z, night_update_night_to_day_0
        cp      4
        jr      z, night_update_night_to_day_1
night_update_do:
        ld      (VAR_night_delay_seconds), a
        ld      a, 0
        ld      b, 10
        call    vdp_set_pal
        ret
;------------------------------------------------------------------------------
night_update_day_to_night_0:
        ld      hl, pal_shop_day_to_night
        ld      a, 1
        jr      night_update_do
night_update_day_to_night_1:
        ld      hl, pal_shop_night
        ld      a, 180
        jr      night_update_do

night_update_night_to_day_0:
        ld      hl, pal_shop_day_to_night
        ld      a, 1
        jr      night_update_do
night_update_night_to_day_1:
        xor     a
        ld      (VAR_night_current), a
        ld      hl, pal_shop
        ld      a, 120
        jr      night_update_do
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
mario_kick_start:
        ld      a, 1
        ld      (VAR_mario_kicking), a
        ld      (VAR_character_anim_frame_max), a
        xor     a
        ld      (VAR_character_anim_frame_cur), a
        ld      a, 180+16+8-12
        ld      (VAR_character_pos_x), a
        ld      a, 192-4*8
        ld      (VAR_character_pos_y), a
        ret
;------------------------------------------------------------------------------
mario_update:
        ld      a, (VAR_character_pos_y)
        sub     1
        ld      (VAR_character_pos_y), a
        ld      a, (VAR_character_pos_x)
        sub     4
        ld      (VAR_character_pos_x), a
        cp      -10
        jr      z, +1
        ret
        xor     a
        ld      (VAR_mario_kicking), a
        call    vdp_disable_sprites
        ld      a, 15
        ld      (VAR_door_anim_delay), a
        ld      a, 3
        ld      (VAR_door_anim_frame_cur), a
        ret
;------------------------------------------------------------------------------

; CHARACTER Code --------------------------------------------------------------
.INCLUDE "char.asm"
;------------------------------------------------------------------------------

; DOOR Code -------------------------------------------------------------------
.INCLUDE "door.asm"
;------------------------------------------------------------------------------

; VDP Library -----------------------------------------------------------------
.INCLUDE "vdp.asm"
;------------------------------------------------------------------------------

; VGM Library -----------------------------------------------------------------
.INCLUDE "vgm.asm"
;------------------------------------------------------------------------------

; DATA ------------------------------------------------------------------------
string_intro:
.db     "IN THE SMS WORLD,", 13
.db     "EVERYBODY COMES TO LOOSE-LOGIC", 13, 13
.db     "HAPPY BIRTHDAY, MASATO!", 13, 13
.db     "                        -OMAR", 13
.db     "CAST:", 0
;string_cast:
;.db     "BOCK LEE TEMJIN", 0
;------------------------------------------------------------------------------
tiles_data:
.INCBIN  "data/data_tiles.bin"
tiles_data_end:
font_data:
.INCLUDE "data/data_font.inc"
font_data_end:
palette_data:
.INCLUDE "data/data_palette.inc"
map_data:
.INCLUDE "data/data_map.inc"
;------------------------------------------------------------------------------

;------------------------------------------------------------------------------
.BANK 1 SLOT 1
;------------------------------------------------------------------------------
.ORGA   $4000
music_data:
.INCBIN  "data/chaprun.vgm"
;------------------------------------------------------------------------------

; SDSC HEADER -----------------------------------------------------------------
.ORGA   $7FE0
        .DB     "SDSC"                  ; Magic
        .DB     $01, $00                ; Version 1.00
        .DB     $27                     ; 27
        .DB     $05                     ; May
        .DW     $2002                   ; 2002
        .DW     sdsc_author
        .DW     sdsc_program_name
        .DW     $FFFF

; CHECKSUM --------------------------------------------------------------------
.ORGA   $7FF0

	.DB	"TMR SEGA"	; Trademark
        .DW     $0120           ; Year
	.DW	$0000		; Checksum not correct
	.DW	$0000		; Part Num not correct
        .DB     $00             ; Version
        .DB     $4C             ; Master System, 32k

;------------------------------------------------------------------------------
.BANK 2 SLOT 2
;------------------------------------------------------------------------------
; Characters data
;------------------------------------------------------------------------------
.ORGA   $8000
.INCLUDE "data/chars/wboy3.inc"
.INCLUDE "data/chars/zillion2.inc"
.INCLUDE "data/chars/akiddmw.inc"
.INCLUDE "data/chars/bakabon.inc"
.INCLUDE "data/chars/aztecadv.inc"
.INCLUDE "data/chars/anmitsuh.inc"
.INCLUDE "data/chars/psychofx.inc"
.INCLUDE "data/chars/theninja.inc"
.INCLUDE "data/chars/gsthouse.inc"
.INCLUDE "data/chars/teddyboy.inc"
.INCLUDE "data/chars/kunfukid.inc"
.INCLUDE "data/chars/pengland.inc"
.INCLUDE "data/chars/rastan.inc"
;------------------------------------------------------------------------------
.BANK 3 SLOT 2
;------------------------------------------------------------------------------
; Characters data
;------------------------------------------------------------------------------
.ORGA   $8000
.INCLUDE "data/chars/spyvsspy.inc"
.INCLUDE "data/chars/myhero.inc"
.INCLUDE "data/chars/phanstar.inc"
.INCLUDE "data/chars/zillion.inc"
.INCLUDE "data/chars/shinobi.inc"
.INCLUDE "data/chars/wboy1.inc"
.INCLUDE "data/chars/borgman.inc"
.INCLUDE "data/chars/ys.inc"
;------------------------------------------------------------------------------
.BANK 4 SLOT 2
;------------------------------------------------------------------------------
; Characters data
;------------------------------------------------------------------------------
.ORGA   $8000
.INCLUDE "data/chars/hokutono.inc"
.INCLUDE "data/chars/dtarget.inc"
.INCLUDE "data/chars/kenseidn.inc"
.INCLUDE "data/chars/psychof2.inc"
.INCLUDE "data/chars/gbasket.inc"
.INCLUDE "data/chars/bublbobl.inc"
.INCLUDE "data/chars/pitpot.inc"
.INCLUDE "data/chars/fntzone2.inc"
.INCLUDE "data/chars/csilver.inc"
.INCLUDE "data/chars/montezum.inc"
.INCLUDE "data/chars/snail.inc"
;------------------------------------------------------------------------------
.BANK 5 SLOT 2
;------------------------------------------------------------------------------
; Characters data
;------------------------------------------------------------------------------
.ORGA   $8000
.INCLUDE "data/chars/rygar.inc"
.INCLUDE "data/chars/wboy2.inc"
.INCLUDE "data/chars/sonic.inc"
.INCLUDE "data/chars/golvlius.inc"
.INCLUDE "data/chars/prowrest.inc"
.INCLUDE "data/chars/akiddls.inc"
.INCLUDE "data/chars/asterix.inc"
.INCLUDE "data/chars/ngaiden.inc"
.INCLUDE "data/chars/dyndux.inc"
.INCLUDE "data/chars/lordswrd.inc"
;------------------------------------------------------------------------------
.BANK 6 SLOT 2
;------------------------------------------------------------------------------
; Characters data
;------------------------------------------------------------------------------
.ORGA   $8000
.INCLUDE "data/chars/akiddsw.inc"
.INCLUDE "data/chars/mgunjoe.inc"
.INCLUDE "data/chars/fntzone1.inc"
.INCLUDE "data/chars/solomonk.inc"
.INCLUDE "data/chars/wsoccer.inc"
.INCLUDE "data/chars/aliensyn.inc"
.INCLUDE "data/chars/kujakuou.inc"
.INCLUDE "data/chars/ddragon.inc"
.INCLUDE "data/chars/mario.inc"
;------------------------------------------------------------------------------
.BANK 7 SLOT 2
;------------------------------------------------------------------------------
.ORGA   $8000
.db     "What are you doing examining this binary file ?"
.ORGA   $A000
.db     "You hacker !"
.ORGA   $BFFF
        nop
;------------------------------------------------------------------------------

