;----------------------------------------------------------------------------
; Sega Master System & Game Gear - VGM Player
; by Omar Cornut / Bock|Zoop (c)
; Started on 6 May 2002
; Last update: 6 May 2002
;----------------------------------------------------------------------------

;----------------------------------------------------------------------------
psg_mute_table:
.db             $9F, $BF, $DF, $FF
psg_mute:
                ld      b, 4
                ld      c, PORT_PSG
                ld      hl, psg_mute_table
                otir
                ret
;----------------------------------------------------------------------------

; VGM_INIT() ----------------------------------------------------------------
; Initialize VGM Player
;----------------------------------------------------------------------------
; No parameter
;----------------------------------------------------------------------------
vgm_init:
vgm_stop:
                xor     a
                ld      (VAR_vgm_playing), a
                ld      (VAR_vgm_waiting_frames), a
                call    psg_mute
                ret
;----------------------------------------------------------------------------


; VGM_PLAY() ----------------------------------------------------------------
; Start VGM Playback
;----------------------------------------------------------------------------
; hl = pointer to VGM song
;----------------------------------------------------------------------------
vgm_play:
                push    bc
                ld      a, 1
                ld      (VAR_vgm_playing), a
                ld      (VAR_vgm_waiting_frames), a
                ld      bc, $40
                add     hl, bc
                ld      (VAR_vgm_song_start), hl
                ld      (VAR_vgm_song_current), hl
                pop     bc
                ret
;----------------------------------------------------------------------------

; VGM_STOP() ----------------------------------------------------------------
; Stop VGM Playback
;----------------------------------------------------------------------------
; No parameter
;----------------------------------------------------------------------------
;vgm_stop:
;                xor     a
;                ld      (VAR_vgm_playing), a
;                call    psg_mute
;                ret
;----------------------------------------------------------------------------


; VGM_UPDATE() --------------------------------------------------------------
; Update VGM Player (should be called at each V-Blank)
;----------------------------------------------------------------------------
; No parameter
;----------------------------------------------------------------------------
vgm_update:
                push    af
                push    bc
                push    hl
                push    de

                ld      hl, (VAR_vgm_song_current)
                ld      a, (VAR_vgm_playing)
                and     a
                jr      z, vgm_update_end

                ld      a, (VAR_vgm_waiting_frames)
                and     a
                jr      z, vgm_update_loop
                dec     a
                ld      (VAR_vgm_waiting_frames), a
                jr      nz, vgm_update_end

vgm_update_loop:
                ld      a, (hl)
                inc     hl

                cp      $50
                jr      z, vgm_update_command_psg

                cp      $61
                jr      z, vgm_update_command_wait

                cp      $66
                jr      z, vgm_update_command_end

;               jr      vgm_update_loop

vgm_update_end:
                ld      (VAR_vgm_song_current), hl
                pop     de
                pop     hl
                pop     bc
                pop     af
                ret
;----------------------------------------------------------------------------
vgm_update_command_psg:
                ld      a, (hl)
                inc     hl
                out     (PORT_PSG), a
                jr      vgm_update_loop
;----------------------------------------------------------------------------
vgm_update_command_wait:
                ld      a, (hl)
                ld      e, a
                inc     hl
                ld      a, (hl)
                ld      d, a
                inc     hl
                push    hl

                push    de
                pop     hl
                ld      d, $FF
                ld      bc, 735
vgm_update_command_wait_count:
                inc     d
                sbc     hl, bc
                jr      nc, vgm_update_command_wait_count

                ld      a, (VAR_vgm_waiting_frames)
                add     a, d
                ld      (VAR_vgm_waiting_frames), a
                pop     hl

                jr      vgm_update_end
;----------------------------------------------------------------------------
vgm_update_command_end:
                ld      hl, (VAR_vgm_song_start)
                jr      vgm_update_end
;----------------------------------------------------------------------------

